<?
/*
* phorSale - An eCommerce application for PHP and mySQL.
* Copyright (C) 2001 Michael Kmiec <mike@shifter.org>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// register the order object, for persistance sake
session_start();

// standard include files
require ("common/config.inc.php");
include("common/common.functions.inc.php");
include("common/order.functions.inc.php");
include("common/shopper.functions.inc.php");


// definitions
$sID = session_id();
$theNewID = generateUniqueID();

    if ( isSet( $AI ) )
    {
        $shopperUpdated = false;
        $orderUpdated = false;

        // validate necessary information
        $errMsg = "";
        if ( !strlen( $shopper_email ) )
            $errMsg .= "<li> You must enter an eMail Address.";        
        else if ( !strlen( $shopper_ship_name ) )
            $errMsg .= "<li> You must enter a Shipping Name.";
        else if ( !strlen( $shopper_ship_addr_1 ) && !strlen( $shopper_ship_addr_2 ) )
            $errMsg .= "<li> You must enter a Shipping Address.";
        else if ( !strlen( $shopper_ship_city ) )
            $errMsg .= "<li> You must enter a Shipping City.";
        else if ( !strlen( $shopper_ship_state ) )  
            $errMsg .= "<li> You must select a Shipping State.";
        else if ( !strlen( $shopper_ship_postal_code ) )
            $errMsg .= "<li> You must enter a Shipping ZIP/Postal Code.";
        else if ( !strlen( $shopper_ship_phone ) )
            $errMsg .= "<li> You must enter a Shipping Telephone Number.";
        else if ( !strlen( $shopper_bill_name ) && ( strcmp( $aba, "yes" ) != 0 ))
            $errMsg .= "<li> You must enter a Billing Name.";
        else if ( ( !strlen( $shopper_ship_addr_1 ) && !strlen( $shopper_ship_addr_2 ) ) && ( strcmp( $aba, "yes" ) != 0 ) )
            $errMsg .= "<li> You must enter a Shipping Address.";
        else if ( !strlen( $shopper_bill_city ) && ( strcmp( $aba, "yes" ) != 0 ))
            $errMsg .= "<li> You must enter a Billing City.";
        else if ( !strlen( $shopper_bill_state ) && ( strcmp( $aba, "yes" ) != 0 ))  
            $errMsg .= "<li> You must select a Billing State.";
        else if ( !strlen( $shopper_bill_postal_code ) && ( strcmp( $aba, "yes" ) != 0 ))
            $errMsg .= "<li> You must enter a Billing ZIP/Postal Code.";
        else if ( !strlen( $shopper_bill_phone ) && ( strcmp( $aba, "yes" ) != 0 ))
            $errMsg .= "<li> You must enter a Billing Telephone Number.";

        // check to see if the two passwords match, if so prepare an updated password
        $updatePW = "";
        $changedPW = false;
        if ( ( strlen( $new_pw ) && strlen( $new_pw_conf ) ) && strcmp( $new_pw, $new_pw_conf ) != 0 )
            $errMsg .= "<li> The Password and Confirm Password do not match. Please make sure they are the same.\n";
        else if ( ( strlen( $new_pw ) && strlen( $new_pw_conf ) ) && strcmp( $new_pw, $new_pw_conf ) == 0 )
        {
            $updatePW = "shopper_password = ENCODE( '$new_pw', '" . md5($shopper_email) ."' ), ";
            $changedPW = true;
        }


        // check if the email entered already exists
        if ( ( $dbh =  mysql_connect( $dbServer, $dbUser, $dbPassword )) > 0 )
        {
            $sql_query = "SELECT shopper_id, shopper_email from shoppers where shopper_email = '$shopper_email'";
            $res = mysql_db_query($dbDatabase, $sql_query, $dbh);

            if ( mysql_num_rows( $res ) > 0 )
            {
                // return the information from the database
                // -----> NOTE: The following will not work if the version of PHP is less than 4.0.3. If this
                // -----> is the case, use mysql_fetch_array( $res ) instead.        
                $dbInfo = mysql_fetch_assoc( $res ); 
                if ( strcmp( $dbInfo["shopper_id"], $shopperID ) != 0 )
                    $errMsg .= "<li> Someone has already entered <i>$shopper_email</i> as an eMail address. Please enter another.\n";
            }

            $dbh = mysql_close();
        }

        if ( strlen( $errMsg ) == 0 )
        {
            // save to the database
            $final["shopper_email"] = $shopper_email;
            $final["shopper_send_email"] = $shopper_send_email;
    		$final["shopper_ship_name"] = $shopper_ship_name;
	    	$final["shopper_ship_company"] = $shopper_ship_company;
		    $final["shopper_ship_phone"] = $shopper_ship_phone;
    		$final["shopper_ship_fax"] = $shopper_ship_fax;
	    	$final["shopper_ship_addr_1"] = $shopper_ship_addr_1;
		    $final["shopper_ship_addr_2"] = $shopper_ship_addr_2;
    		$final["shopper_ship_city"] = $shopper_ship_city;
	    	$final["shopper_ship_state"] = $shopper_ship_state;
		    $final["shopper_ship_postal_code"] = $shopper_ship_postal_code;
    		$final["shopper_ship_country"] = $shopper_ship_country;

            // if shipping and billing addresses are the same, apply this information
            if( strcmp( $aba, "yes" ) == 0 )
            {
                $final["shopper_bill_name"] = $shopper_ship_name;
	    	    $final["shopper_bill_company"] = $shopper_ship_company;
		        $final["shopper_bill_phone"] = $shopper_ship_phone;
    		    $final["shopper_bill_fax"] = $shopper_ship_fax;
	    	    $final["shopper_bill_addr_1"] = $shopper_ship_addr_1;
		        $final["shopper_bill_addr_2"] = $shopper_ship_addr_2;
    		    $final["shopper_bill_city"] = $shopper_ship_city;
	    	    $final["shopper_bill_state"] = $shopper_ship_state;
		        $final["shopper_bill_postal_code"] = $shopper_ship_postal_code;
    		    $final["shopper_bill_country"] = $shopper_ship_country;             
            }
            else
            {
                $final["shopper_bill_name"] = $shopper_bill_name;
	    	    $final["shopper_bill_company"] = $shopper_bill_company;
		        $final["shopper_bill_phone"] = $shopper_bill_phone;
    		    $final["shopper_bill_fax"] = $shopper_bill_fax;
	    	    $final["shopper_bill_addr_1"] = $shopper_bill_addr_1;
		        $final["shopper_bill_addr_2"] = $shopper_bill_addr_2;
    		    $final["shopper_bill_city"] = $shopper_bill_city;
	    	    $final["shopper_bill_state"] = $shopper_bill_state;
		        $final["shopper_bill_postal_code"] = $shopper_bill_postal_code;
    		    $final["shopper_bill_country"] = $shopper_bill_country;
            }

    		$updates = "";
	    	while (list($name, $value) = each($final))
            {
                if ( strlen ( $updates ) )
                    $updates .= ", ";

		    	$updates .= "$name = '$value'";
            }
	
		    // Execute the update
    		if ( ( $dbh =  mysql_connect( $dbServer, $dbUser, $dbPassword )) > 0 )
	        {
		    	$sql_query = "UPDATE $shopperTable SET $updatePW $updates WHERE shopper_id = '$eCommID'";

                //echo $sql_query;
                //exit;


			    $res = mysql_db_query($dbDatabase, $sql_query, $dbh);
    			$err = mysql_error();

	    		$shopperUpdated = ( $err ) ? false : true;

		    	$dbh = mysql_close();
		    }

            // if the user changed PW, send them to the login page; same logic applies with a "logout"
            if ( $changedPW )                
                header("Location: shopperCheck.php?neweCommID=$theNewID&PHPSESSID=" . $sID . "&np=a" );
        }
    }

    $shopper = getShopper( $shopperID );

    // if there's an error, display any passed-in form information, but display the
    // original email address - the only unique identifer.
    if ( strlen( $errMsg ) )
    {
        $shopper[opt_in] = $shopper_send_email;

        $shopper[sname] = $shopper_ship_name;
        $shopper[scompany] = $shopper_ship_company;
        $shopper[sphone] = $shopper_ship_phone;
        $shopper[sfax] = $shopper_ship_fax;
        $shopper[saddr_1] = $shopper_ship_addr_1;
        $shopper[saddr_2] = $shopper_ship_addr_2;
        $shopper[scity] = $shopper_ship_city;
        $shopper[sstate] = $shopper_ship_state;
        $shopper[spostal_code] = $shopper_ship_postal_code;
        $shopper[scountry] = $shopper_ship_country;

        $shopper[bname] = $shopper_bill_name;
        $shopper[bcompany] = $shopper_bill_company;
        $shopper[bphone] = $shopper_bill_phone;
        $shopper[bfax] = $shopper_bill_fax;
        $shopper[baddr_1] = $shopper_bill_addr_1;
        $shopper[baddr_2] = $shopper_bill_addr_2;
        $shopper[bcity] = $shopper_bill_city;
        $shopper[bstate] = $shopper_bill_state;
        $shopper[bpostal_code] = $shopper_bill_postal_code;
        $shopper[bcountry] = $shopper_bill_country;
    }

    $optInChecked = ( $shopper[opt_in] == "true" ) ? "CHECKED" : "";

    $title = "My Account";
    require 'common/header.inc.php';
?>

<font face="<?echo $fontTag;?>" size="+2" color="#000000">My Account</font>
<hr size="1">
<font face="<?echo $fontTag;?>" color="#000000" size="-1"><a href="<? echo $secure_url_prefix;?>shopperCheck.php?neweCommID=<? echo $theNewID; ?>&PHPSESSID=<?echo $sID;?>">Log Out</a> | <a href="<? echo $secure_url_prefix;?>placedOrders.php?eCommID=<?echo $shopperID;?>&PHPSESSID=<?echo $sID;?>">My Placed Orders</a></font>
<p>

<form action="<?echo basename($PHP_SELF);?>" method="POST">
<input type="hidden" name="eCommID" value="<?echo $shopperID;?>">
<input type="hidden" name="PHPSESSID" value="<?echo $sID;?>">
<input type="hidden" NAME="AI" VALUE="true">

<table border="0" cellspacing="1" width="80%">

<?
if ( strlen( $errMsg ) ) 
{
?>
    <tr>
        <td colspan="2" align="left">
            <font face="<?echo $fontTag; ?>" size="2" color="#CC0000"><b>
                There appears to be a problem...
            <ul><?echo $errMsg;?></ul>
            </b></font><p>
        </td>
    </tr>
<?
}
if ( $shopperUpdated ) 
{
?>
    <tr>
        <td colspan="2" align="center">
            <font face="<?echo $fontTag; ?>" size="2" color="green"><b>Your Account Information is updated.</b></font><p>
        </td>
    </tr>
<?
}
?>
    <tr>
        <td align="center" colspan="2"><font face="<?echo $fontTag;?>" size="2">Please enter your Account Information. All information in <font color="green"><b>green</b></font> is required.</font><p></td>
    </tr>
    <tr bgcolor="#E7E7E9">
        <td colspan="2" align="left"><font face="<?echo $fontTag;?>">Login Information</font></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>eMail Address</b></font></font></td>
        <td><input type="text" maxlength="200" name="shopper_email" size="30" value="<? echo $shopper[email]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2">New Password?</font></td>
        <td><input type="password" maxlength="60" size="30" name="new_pw"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"> Confirm New Password</font></td>
        <td><input type="password" maxlength="60" size="30" name="new_pw_conf"></td>
    </tr>
    <tr>
        <td colspan="2" align="center"><font face="<?echo $fontTag;?>" size="-2" color="#CC0000"><b>Note:</b> Changing your password requires you to login with the new password.</font></td>
    </tr>
    <tr>
        <td width="100%" align="center" colspan="2">
            <input type="submit" value="Update Information">
        </td>
    </tr>
    <tr>
        <td colspan="2">&nbsp;</td>
    </tr>
    
    <tr bgcolor="#E7E7E9">
        <td colspan="2" align="left"><font face="<?echo $fontTag;?>">eMail Preferences</font></td>
    </tr>
    <tr>
        <td align="center" colspan="2">
        <font face="<?echo $fontTag;?>" size="-1">
            <blockquote>
            From time to time, eCommerce Company will send eMail information about products, services or special offers. 
            If you wish to recieve this eMail, check this box.
            </blockquote>            
            <input type="checkbox" name="shopper_send_email" value="true" <? echo $optInChecked;?>>&nbsp;
            Please send me eMail from eCommerce Company.                        
        </font></td>
    </tr>
    <tr>
        <td width="100%" align="center" colspan="2">
            <input type="submit" value="Update Information">
        </td>
    </tr>

    <tr>
        <td colspan="2">&nbsp;</td>
    </tr>

    <tr bgcolor="#E7E7E9">
        <td colspan="2" align="left"><font face="<?echo $fontTag;?>">Shipping Information</font></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>Name</b></font></font></td>
        <td><input type="text" maxlength="60" size="30" name="shopper_ship_name" value="<? echo $shopper[sname]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2">Company</font></td>
        <td><input type="text" maxlength="200" name="shopper_ship_company" size="30" value="<? echo $shopper[scompany]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>Address Line 1</b></font></font></td>
        <td><input type="text" maxlength="70" name="shopper_ship_addr_1" size="30" value="<? echo $shopper[saddr_1]; ?>"'></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2">Address Line 2</font></td>
        <td><input type="text" maxlength="70" name="shopper_ship_addr_2" size="30" value="<? echo $shopper[saddr_2]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>City</b></font></font></td>
        <td><input type="text" maxlength="40" name="shopper_ship_city" size="30" value="<? echo $shopper[scity]; ?>"></font></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>State</b></font></font></td>
        <td>
            <? echo buildStateList( "shopper_ship_state", $shopper[sstate] ); ?>
        </td>
    </tr>  
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>ZIP/Postal Code</b></font></font></td>
        <td><input maxLength="11" name="shopper_ship_postal_code" size="12" value="<? echo $shopper[spostal_code]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>Telephone</b></font></font></td>
        <td><input type="text" maxlength="40" name="shopper_ship_phone" size="30" value="<? echo $shopper[sphone]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2">Fax</font></td>
        <td><input type="text" maxlength="40" name="shopper_ship_fax" size="30" value="<? echo $shopper[sfax]; ?>"></td>
    </tr>
    <tr>
        <td colspan="2">&nbsp;</td>
    </tr>
    <tr>
        <td align="right" valign="top"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>Is this the same<br>as your Billing Address?</b></font></font></td>
        <td valign="top"><font face="<?echo $fontTag;?>" size="2">
            <input type="radio" name="aba" value="yes" checked> Yes
            &nbsp;&nbsp;
            <input type="radio" name="aba" value="no"> No
        </td>
    </tr>
    <tr>
        <td width="100%" align="center" colspan="2">
            <input type="submit" value="Update Information">
        </td>
    </tr>
    <tr>
        <td colspan="2">&nbsp;</td>
    </tr>
    <tr bgcolor="#E7E7E9">
        <td colspan="2" align="left"><font face="<?echo $fontTag;?>">Billing Information</font></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>Name</b></font></font></td>
        <td><input type="text" maxlength="60" size="30" name="shopper_bill_name" value="<? echo $shopper[bname]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2">Company</font></td>
        <td><input type="text" maxlength="200" name="shopper_bill_company" size="30" value="<? echo $shopper[bcompany]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>Address Line 1</b></font></font></td>
        <td><input type="text" maxlength="70" name="shopper_bill_addr_1" size="30" value="<? echo $shopper[baddr_1]; ?>"'></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2">Address Line 2</font></td>
        <td><input type="text" maxlength="70" name="shopper_bill_addr_2" size="30" value="<? echo $shopper[baddr_2]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>City</b></font></font></td>
        <td><input type="text" maxlength="40" name="shopper_bill_city" size="30" value="<? echo $shopper[bcity]; ?>"></font></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>State</b></font></font></td>
        <td>
            <? echo buildStateList( "shopper_bill_state", $shopper[bstate] ); ?>
        </td>
    </tr>  
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>ZIP/Postal Code</b></font></font></td>
        <td><input maxLength="11" name="shopper_bill_postal_code" size="12" value="<? echo $shopper[bpostal_code]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2"><font color="green"><b>Telephone</b></font></font></td>
        <td><input type="text" maxlength="40" name="shopper_bill_phone" size="30" value="<? echo $shopper[bphone]; ?>"></td>
    </tr>
    <tr>
        <td align="right"><font face="<?echo $fontTag;?>" size="2">Fax</font></td>
        <td><input type="text" maxlength="40" name="shopper_bill_fax" size="30" value="<? echo $shopper[bfax]; ?>"></td>
    </tr>
    
    <tr>
        <td width="100%" align="center" colspan="2">
            <input type="submit" value="Update Information">
        </td>
    </tr>
</table>
</form>

<? require 'common/footer.inc.php'; ?>