<?
/*
* phorSale - An eCommerce application for PHP and mySQL.
* Copyright (C) 2001 Michael Kmiec <mike@shifter.org>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

require ("../common/config.inc.php");
include("../common/common.functions.inc.php");
require ("../common/admin.authorize.inc.php");

// upon submission, add a new product
if ( isSet($AP) )
{
    // all we *really* need is a product id to hold the space in the database, 
    // but a name should be there for linking purposes
	if ( isSet( $product_id ) && isSet( $product_name ))
	{

        // get information about the image, if provided
        if ( !empty( $product_image ) && $product_image != "none" )
        {
		    $size = GetImageSize($product_image);
    		$productInfo["product_image_width"] = $size[0];
	    	$productInfo["product_image_height"] = $size[1];
		    $ext = substr($product_image_name, strrpos($product_image_name, ".")+1);    		
	    	$valid_image = true;

	        // We'll only accept images (i.e. files with an image extension.)
		    switch (strtoupper($ext))
		    {
			    case "JPEG":
    			case "JPG":
	    			$productInfo["product_image_format"] = "jpeg";
		    		break;
			    case "PNG":
				    $productInfo["product_image_format"] = "png";
    				break;
	    		case "GIF":
		    		$productInfo["product_image_format"] = "gif";
			    	break;
    			default:
	    			$valid_image = false;
		    		break;		
		    }

		    if ( $valid_image )
			    $productInfo["product_image"] = addslashes(fread(fopen($product_image, "r"), filesize($product_image)));
        }

        $colorList = "";
        if ( isSet( $productColors ) )
        {
            foreach ( $productColors as $prodCol )
	    	{
		    	if ( strlen( $colorList ) ) 
			    	$colorList .= ",";

    			$colorList .= $prodCol;
	    	}
        }
    
		$productAdded = false;
		$productInfo["product_id"] = $product_id;
		$productInfo["product_active"] = $product_active;
		$productInfo["product_name"] = $product_name;
		$productInfo["product_desc"] = $product_desc;
		$productInfo["product_section"] = $product_section;
		$productInfo["product_specs"] = $product_specs;
		$productInfo["product_keywords"] = $product_keywords;
        $productInfo["product_colors"] = $colorList;
		$productInfo["product_option_one"] = $product_option_one;
		$productInfo["product_option_two"] = $product_option_two;
		$productInfo["product_option_three"] = $product_option_three;
		$productInfo["product_option_four"] = $product_option_four;
		$productInfo["product_weight"] = $product_weight;
		$productInfo["product_weight_count"] = $product_weight_count;
		$productInfo["product_turnaround"] = $product_turnaround;
		$productInfo["product_disclaimer"] = $product_disclaimer;
        $productInfo["product_shipping_from"]= $product_shipping_from;

        $cleanPrice = str_replace( "$", "", $product_price );
        $productInfo["product_price"]= ( strcasecmp( $cleanPrice, "n/a" ) != 0 ) ? $cleanPrice : 0;

        $cleanSpecialPrice = str_replace( "$", "", $product_special_price );
        $productInfo["product_special_price"]= ( strcasecmp( $cleanSpecialPrice, "n/a" ) != 0 ) ? $cleanSpecialPrice : 0;
        

        // Don't add an "empty" Image to table
		if (empty($productInfo["product_image"]) || $productInfo["product_image"] == "none")
			unset($productInfo["product_image"]);
       
	    // Build the lists of columns and their values
		$columns = "";
		$values = "";
		while (list($name, $value) = each($productInfo))
		{
            if ( strlen( $columns ) > 0 )
                $columns .= ", ";    
            
            if ( strlen( $values ) > 0 ) 
                $values .= ", ";

			$columns .= "$name";
			$values .= "'$value'";        
		}
	
		// Execute the insert
		if ( ( $dbh =  mysql_connect( $dbServer, $dbUser, $dbPassword )) > 0 )
        {
		    $sql_query = "INSERT INTO $productTable ($columns) VALUES ($values)";         


            //echo $sql_query;
            //exit;
            
            $res = mysql_db_query($dbDatabase, $sql_query, $dbh);
            $err = mysql_error();

            $productAdded = ( $err ) ? false : true;         

            $dbh = mysql_close();      
        }

	}
}

?>


<? $title = "Add Product"; ?>
<? require 'header.php'; ?>

<font face="<?echo $fontTag;?>" SIZE="+2" COLOR="#000000">Add Product</font><hr size="1">

<center>

<? 
	if ( isSet($AP) )
	{	
		if ( $productAdded )
			echo "<font face=\"$fontTag;\" size=\"+1\" color=\"#006633\">" . str_replace( "REPLACE", $productInfo["product_name"], $adminMsgProductAdded ) . "</font>";
		else
			echo "<font face=\"$fontTag;\"  size=\"+1\" color=\"red\">$adminMsgProductAddFail</font><br>$err<br>$price_err<br>";
	}
?>


<form action="<?echo basename($PHP_SELF);?>" method="POST" enctype="multipart/form-data">

<table border="0" cellspacing="0" cellpadding="1" bgcolor="#FFFFFF">
	<tr align="center">
		<td>
		<table width="100%" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td>
				<table border="0" cellpadding="4">
					<tr>
						<td><font face="<?echo $fontTag;?>">Product ID:</font></td>
						<td><input type="text" name="product_id" size="15" maxlength="15"></td>
					</tr>					
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Name:</font></td>
						<td><input type="text" name="product_name" size="50" maxlength="50"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Image:</font></td>
						<td><input type="file" name="product_image"></td>
					</tr>
					<tr>
						<td valign="top"><font face="<?echo $fontTag;?>">Product Description:</font></td>
						<td valign="middle"><textarea name="product_desc" cols="60" rows="8"></textarea></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Section:</font></td>
						<td>
							<? echo selectBox( 'product_section', 'sections', 'section_id', 'section_name' ); ?>							
						</td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Specifications:</font></td>								
						<td><input type="text" name="product_specs" size="25" maxlength="255"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Keywords:</font></td>								
						<td><input type="text" name="product_keywords" size="25" maxlength="255"></td>
					</tr>
                    <tr>
						<td><font face="<?echo $fontTag;?>">Product Colors:</font></td>
						<td>
                            <? echo selectBox( "productColors[]", "colors", "color_id", "color_name", "", 5 ); ?>
                        </td>
					</tr>

					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option One:</font></td>								
						<td><input type="text" name="product_option_one" size="25" maxlength="100"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option Two:</font></td>								
						<td><input type="text" name="product_option_two" size="25" maxlength="100"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option Three:</font></td>								
						<td><input type="text" name="product_option_three" size="25" maxlength="100"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option Four:</font></td>								
						<td><input type="text" name="product_option_four" size="25" maxlength="100"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Shipping Info:</font></td>								
						<td>
							<input type="text" name="product_weight" size="4" maxlength="5">
							 <font face="<?echo $fontTag;?>">pounds per</font> 
							<input type="text" name="product_weight_count" size="4" maxlength="5">
                            <font face="<?echo $fontTag;?>">units</font>
						</td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Turnaround Time:</font></td>								
						<td>
							<input type="text" name="product_turnaround" size="4" maxlength="5">
							 <font face="<?echo $fontTag;?>">business days</font> 
						</td>
					</tr>
                    <tr>
						<td><font face="<?echo $fontTag;?>">Shipping From:</font></td>								
						<td>
							<input type="text" name="product_shipping_from" size="5" maxlength="10">
							 <font face="<?echo $fontTag;?>">(ZIP code)</font> 
						</td>
					</tr>
					<tr>
						<td valign="top"><font face="<?echo $fontTag;?>">Disclaimer:</font></td>								
						<td valign="middle"><textarea name="product_disclaimer" cols="60" rows="8"></textarea></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Price:</font></td>								
						<td><input type="text" name="product_price" size="25" maxlength="75"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Special Price:</font></td>
						<td><input type="text" name="product_special_size" size="25" maxlength="75"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Is Product Active?</font></td>
						<td><input type="checkbox" name="product_active" value="true" checked></td>
					</tr>
					<tr>
						<td colspan="2" align="center"> 
							<input type="submit" name="AP" value="<?echo $adminMsgProductAddSubmit;?>">
						</td>
					</tr>
					<tr>
						<td colspan="2" align="left"> 
							<font face="<?echo $fontTag;?>" size="-1">
								<a href="<? echo $url_prefix; ?>"><?echo $adminMsgViewStore;?></a>
							</font>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</form>

<center>

<? require 'footer.php'; ?>