<?
/*
* phorSale - An eCommerce application for PHP and mySQL.
* Copyright (C) 2001 Michael Kmiec <mike@shifter.org>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

    require ("../common/config.inc.php");
    include("../common/common.functions.inc.php");
    require ("../common/admin.authorize.inc.php");

    // if this has not been set, redirect
	if( !isSet( $product_id ) && !isSet( $product_name ))
	{
		Header( "Location: index.php" );    
		exit;
	}

	// upon submission, update product
	if ( isSet($UD) )
	{
		if (!empty($product_image) && $product_image != "none")
		{
			$size = GetImageSize($product_image);
			$final["product_image_width"] = $size[0];
			$final["product_image_height"] = $size[1];
			$ext = substr($product_image_name, strrpos($product_image_name, ".")+1);
			
			$valid_image = true;

			// We'll only accept images (i.e. files with an image extension.)
			switch (strtoupper($ext))
			{
				case "JPEG":
				case "JPG":
					$final["product_image_format"] = "jpeg";
					break;
				case "PNG":
					$final["product_image_format"] = "png";
					break;
				case "GIF":
					$final["product_image_format"] = "gif";
					break;
				default:
					$valid_image = false;
					break;		
			}

			if ( $valid_image )
				$final["product_image"] = addslashes(fread(fopen($product_image, "r"), filesize($product_image)));
		}
		
        $colorList = "";

        if ( isSet( $productColors ) )
        {
            foreach ( $productColors as $prodCol )
	    	{
		    	if ( strlen( $colorList ) ) 
			    	$colorList .= ",";

    			$colorList .= $prodCol;
	    	}
        }

		$productUpdated = false;

   		if ( isSet( $product_active ) )
			$final["product_active"] = "true"; 
		else 
			$final["product_active"] = "false";

		$final["product_name"] = $product_name;
		$final["product_desc"] = $product_desc;

        if ( isSet( $isSpecial ) && $isSpecial == "true" )
            $final["product_section"] = 0;
		else 
			$final["product_section"] = $product_section;
		
		$final["product_specs"] = $product_specs;
		$final["product_keywords"] = $product_keywords;
        $final["product_colors"] = $colorList;
		$final["product_option_one"] = $product_option_one;
		$final["product_option_two"] = $product_option_two;
		$final["product_option_three"] = $product_option_three;
		$final["product_option_four"] = $product_option_four;
		$final["product_weight"] = $product_weight;
		$final["product_weight_count"] = $product_weight_count;
		$final["product_turnaround"] = $product_turnaround;
        $final["product_shipping_from"] = $product_shipping_from;
		$final["product_disclaimer"] = $product_disclaimer;
        $final["product_price"] = $product_price;
        $final["product_special_price"] = $product_special_price;

        // Don't add an "empty" Image to table
		if (empty($final["product_image"]) || $final["product_image"] == "none")
		{
			unset($final["product_image"]);
			unset($final["product_image_format"]);
		}

		$updates = "";
		while (list($name, $value) = each($final))
        {
            if ( strlen( $updates ) > 0 )
                $updates .= ", ";    

			$updates .= "$name = '$value'";
        }
	
		// Execute the update
		if ( ( $dbh =  mysql_connect( $dbServer, $dbUser, $dbPassword )) > 0 )
	    {
			$sql_query = "UPDATE $productTable SET $updates WHERE product_id = '$product_id'";

			$res = mysql_db_query($dbDatabase, $sql_query, $dbh);
			$err = mysql_error();

			$productUpdated = ( $err ) ? false : true;

			$dbh = mysql_close();
		}

	}

    // get the product from the database
    if ( ( $dbh =  mysql_connect( $dbServer, $dbUser, $dbPassword )) > 0 )
    {
        $sql_query = "SELECT * FROM $productTable WHERE product_id = '$product_id'";

        $res = mysql_db_query($dbDatabase, $sql_query, $dbh);
        
        $dbh = mysql_close();        
    }

	$product = mysql_fetch_array( $res );
	$thumbnail = reduceImage( $product );
?>


<? $title = "Edit $product[product_name] ($product[product_id])"; ?>
<? require 'header.php'; ?>

<font face="<?echo $fontTag;?>" SIZE="+2" COLOR="#000000">Edit Product</font><hr size="1">

<center>

<? 
	if ( isSet($UD) )
	{	
		if ( $productUpdated )
			echo "<font face=\"$fontTag;\" size=\"+1\" color=\"#006633\">" . str_replace( "REPLACE", $final["product_name"], $adminMsgProductUpdated ) . "</font>";
		else
			echo "<font face=\"$fontTag;\"  size=\"+1\" color=\"red\">$adminMsgProductUpdateFail</font><br>$err<br>$price_err<br>";
	}
?>

<form action="<?echo basename($PHP_SELF);?>" method="POST" enctype="multipart/form-data">
<input type="hidden" name="product_id" value="<?echo trim($product[product_id]);?>">

<table border="0" cellspacing="0" cellpadding="1" bgcolor="#FFFFFF">
	<tr align="center">
		<td>
		<table width="100%" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td>
				<table border="0" cellpadding="4">
                    <?
                    // is this the "active" special? if so, then flag it.
                    if ( $product[product_section] == 0 )
                    {
                    ?>
                    <tr>
						<td><font face="<?echo $fontTag;?>">Is this is the Current Special?</font></td>
						<td><font face="<?echo $fontTag;?>"><input type="checkbox" name="isSpecial" value="true" checked> Yes</font></td>
					</tr>
                    <?
                    }
                    ?>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product ID:</font></td>
						<td><font face="<?echo $fontTag;?>"><?echo trim($product[product_id]);?></font></td>
					</tr>					
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Name:</font></td>
						<td><input type="text" name="product_name" size="50" maxlength="50" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_name]));?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Image:</font></td>
						<td valign="middle" align="left"><img src="<?echo $url_prefix;?>viewImage.php?product_id=<?echo trim($product[ product_id ]);?>" width="<?echo $thumbnail[width];?>" height="<?echo $thumbnail[height];?>" border="0" align="absmiddle">&nbsp;&nbsp;<input type="file" name="product_image"></td>
					</tr>
					<tr>
						<td valign="top"><font face="<?echo $fontTag;?>">Product Description:</font></td>
						<td valign="middle"><textarea name="product_desc" cols="60" rows="8"><?echo trim( str_replace ( "\"", "&quot;", $product[product_desc]));?></textarea></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Section:</font></td>
						<td>							
							<? echo selectBox( 'product_section', 'sections', 'section_id', 'section_name', trim($product[product_section]), "", true ); ?>
						</td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Specifications:</font></td>								
						<td><input type="text" name="product_specs" size="25" maxlength="255" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_specs] ) );?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Keywords:</font></td>								
						<td><input type="text" name="product_keywords" size="25" maxlength="255" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_keywords]));?>"></td>
					</tr>
                    <tr>
						<td><font face="<?echo $fontTag;?>">Product Colors:</font></td>
						<td>
                            <? echo selectBox( "productColors[]", "colors", "color_id", "color_name", trim($product[product_colors]), 5 ); ?>
                        </td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option One:</font></td>								
						<td><input type="text" name="product_option_one" size="25" maxlength="100" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_option_one]));?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option Two:</font></td>								
						<td><input type="text" name="product_option_two" size="25" maxlength="100" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_option_two]));?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option Three:</font></td>								
						<td><input type="text" name="product_option_three" size="25" maxlength="100" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_option_three]));?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Product Option Four:</font></td>								
						<td><input type="text" name="product_option_four" size="25" maxlength="100" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_option_four]));?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Shipping Info:</font></td>								
						<td>
							<input type="text" name="product_weight" size="4" maxlength="5" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_weight]));?>">
							 <font face="<?echo $fontTag;?>">pounds per</font> 
							<input type="text" name="product_weight_count" size="4" maxlength="5" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_weight_count]));?>">
                             <font face="<?echo $fontTag;?>">units</font> 
						</td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Turnaround Time:</font></td>								
						<td>
							<input type="text" name="product_turnaround" size="4" maxlength="5" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_turnaround]));?>">
							 <font face="<?echo $fontTag;?>">business days</font> 
						</td>
					</tr>
                    <tr>
					<td><font face="<?echo $fontTag;?>">Shipping From:</font></td>
						<td>
							<input type="text" name="product_shipping_from" size="5" maxlength="10" value="<?echo trim( str_replace ( "\"", "&quot;", $product[product_shipping_from]));?>">
							 <font face="<?echo $fontTag;?>">(ZIP code)</font> 
						</td>
					</tr>
					<tr>
						<td valign="top"><font face="<?echo $fontTag;?>">Disclaimer:</font></td>								
						<td valign="middle"><textarea name="product_disclaimer" cols="60" rows="8"><?echo trim(str_replace ( "\"", "&quot;", $product[product_disclaimer]));?></textarea></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Price:</font></td>
                        <?
                            if ( $product[product_price] == 0.00 )
                                $showPrice = "N/A";
                            else
                                $showPrice = trim( str_replace ( "\"", "&quot;", $product[product_price]));
                        ?>
						<td><input type="text" name="product_price" size="25" maxlength="75" value="<?echo $showPrice;?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Special Price:</font></td>
                        <?
                            if ( $product[product_special_price] == 0.00 )
                                $showSpecial = "N/A";
                            else
                                $showSpecial = trim( str_replace ( "\"", "&quot;", $product[product_special_price]));
                        ?>
						<td><input type="text" name="product_special_price" size="25" maxlength="75" value="<?echo $showSpecial;?>"></td>
					</tr>
					<tr>
						<td><font face="<?echo $fontTag;?>">Is Product Active?</font></td>
						<? $checked = ( strcmp( trim($product[product_active]), "true" ) == 0 ) ? "checked" : ""; ?>
						<td><input type="checkbox" name="product_active" value="true" <?echo $checked;?>></td>
					</tr>
					<tr>
						<td colspan="2" align="center"> 
							<input type="submit" name="UD" value="<?echo $adminMsgProductUpdateSubmit;?>">
						</td>
					</tr>
					<tr>
                        <td align="left"> 
							<font face="<?echo $fontTag;?>" size="-1">
								<a href="<? echo $admin_url_prefix; ?>editListing.php">Return to Product Listing</a>
							</font>							
						</td>
                        <td align="right"> 
                            <font face="<?echo $fontTag;?>" size="-1">
								<a href="<? echo $url_prefix; ?>"><?echo $adminMsgViewStore;?></a>
							</font>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</form>

<center>        

<? require 'footer.php'; ?>