<?
/*
* phorSale - An eCommerce application for PHP and mySQL.
* Copyright (C) 2001 Michael Kmiec <mike@shifter.org>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*****
* This file includes a variety of shared, globally available functions.
*****/

// *****
// Returns an associative array with height and width attributes
// of a resized image, for thumbnails. Function keeps proportions the same.
function reduceImage( $img_row ) 
{    
    // picsize variable controls maximum size of the height/width
    $picsize = 100;
    
    $dim[height] = $img_row[ "product_image_height" ];
    $dim[width] = $img_row[ "product_image_width" ];

    while( $dim[width] > $picsize )
    {
        $dim[width] = $dim[width] * .5;
        $widthreduce++; 
    }
        
    for( $heightreduce = 0; $heightreduce < $widthreduce; $heightreduce++ )
    {
        $dim[height] = $dim[height] * .5;
    }

    while($dim[height] > $picsize)
    {
        $dim[height] = $dim[height] * .5;
        $heightreduce++; 
    }
        
    for($widthreduce=$widthreduce; $widthreduce < $heightreduce; $widthreduce++)
    {
        $dim[width] = $dim[width] * .5;
    }

    $dim[height] = (int)$dim[height]; $dim[width] = (int)$dim[width];

    return $dim;
}

// *****
// Build an HTML select box from database based on passed parameters.
function selectBox( $htmlTag, $table, $optionValue, $option, $optionSelected = "", $multi = "", $showAll = false )
{
	global $dbServer, $dbUser, $dbPassword, $dbDatabase;

    if ( strlen( $multi ) )
        $retStr = "<select name=\"$htmlTag\" multiple size=\"$multi\">\n";
    else
	    $retStr = "<select name=\"$htmlTag\">\n";

	if ( ( $dbh =  mysql_connect( $dbServer, $dbUser, $dbPassword )) > 0 )
	{
        if ( $showAll ) // used primarily for admin pages
            $sql_query = "SELECT $option, $optionValue FROM $table ORDER BY $option ASC;";
        else if ( ( !strlen( $multi ) ) && ( strlen( $optionSelected ) ) )
		    $sql_query = "SELECT $option, $optionValue FROM $table where $optionValue IN ( $optionSelected ) ORDER BY $option ASC;";
        else
            $sql_query = "SELECT $option, $optionValue FROM $table ORDER BY $option ASC;";

		$res = mysql_db_query( $dbDatabase, $sql_query, $dbh );
		$dbh = mysql_close();
	}

	$numRows = mysql_num_rows( $res );

	// manipulate the records returned from the database
	if ( $numRows > 0 )
	{
		while ( $cur_row = mysql_fetch_array( $res ) )
		{
			// check to see if one of the options needs to be selected
			if ( strlen( $optionSelected ) )
			{
                $temp = "";

                if ( strlen( $multi ) )
                {
                    $temp .= "<option value=\"" . $cur_row["$optionValue"] . "\"> " .  $cur_row["$option"] . "\n";
                 
                    // the options for multiple selects are in comma-delimited strings
                    $multiString = explode( ",", $optionSelected );

                    for ($i = 0; $i < count( $multiString ); $i++)
                    {
                        $valStr = "value=\"" . $multiString[$i] . "\">";
                        
                        if ( strstr( $temp, $valStr ) )
                        {
                            $newValStr = "value=\"" . $multiString[$i] . "\" SELECTED>";
                            $temp = str_replace ( $valStr, $newValStr, $temp);
                        }
                    }
                }
                else
                {
				    if ( strcmp( $optionSelected, $cur_row["$optionValue"] ) == 0 )
					    $retStr .= "<option value=\"" . $cur_row["$optionValue"] . "\" SELECTED> " .  $cur_row["$option"] . "\n";
				    else
				    	$retStr .= "<option value=\"" . $cur_row["$optionValue"] . "\"> " .  $cur_row["$option"] . "\n";
                }

                if ( strlen( $temp ) )
                    $retStr .= $temp;
			}
			else
				$retStr .= "<option value=\"" . $cur_row["$optionValue"] . "\"> " .  $cur_row["$option"] . "\n";
		}

		mysql_free_result ($res);
	}    

	$retStr .= "</select>\n";

	return $retStr;
}

// *****
// Build an HTML select box based on passed string, usually retrieved from database.
// Format is usually "OPTION_NAME: OPTION_VAL_1, OPTION_VAL_2...OPTION_VAL_n"
function stringSelectBox( $inStr, $htmlTag, $firstDelim = ":", $secondDelim = "," )
{
    $retStr = "";

    // make the select box for options
    $options = explode( $firstDelim, trim( $inStr ) );

    $retStr .= trim( $options[0] ) . ": <select name=\"$htmlTag\">\n";

    $subOptions = explode( $secondDelim, trim( $options[1] ) );

    for ($i = 0; $i < count( $subOptions ); $i++) 
        $retStr .= "<option value=\"" . trim($subOptions[$i]) . "\"> " . trim($subOptions[$i]);

    $retStr .= "</select>\n";

    return $retStr;
}

// *****
// Strip and return the OPTION_NAME from a string, as in above, usually retrieved from database.
// Format is usually "OPTION_NAME: OPTION_VAL_1, OPTION_VAL_2...OPTION_VAL_n"
function stringOptionName( $inStr, $firstDelim = ":" )
{
    $retStr = "";

    // make the split on the delimiter
    $options = explode( $firstDelim, trim( $inStr ) );

    $retStr = trim( $options[0] );

    return $retStr;
}

// *****
// Build the navigation for paging through a database result set
function resultSetNav( $limitOffset, $numResults, $pageName = "", $xtraQuery = "" )
{
	global $recordsPerPage;
	$lo = $limitOffset;

    if ( strlen( $pageName ) == 0 )
        $pageName = basename($PHP_SELF);

    if ( strlen( $xtraQuery ) )
    {
        $retStr .= ( $lo > 0 ) ? "<a href=" . $pageName . "?lo=" . ( $lo - $recordsPerPage ) . "&" . $xtraQuery . ">&lt;&lt; Previous</a>&nbsp;" : "" ;
	    $retStr .= ( ($recordsPerPage + $lo) < $numResults ) ? "&nbsp;<a href=" . $pageName . "?lo=" . ( $recordsPerPage + $lo ) . "&" . $xtraQuery . ">Next &gt;&gt;</a>" : "";
    }
    else
    {
	    $retStr .= ( $lo > 0 ) ? "<a href=" . $pageName . "?lo=" . ( $lo - $recordsPerPage ) . ">&lt;&lt; Previous</a>&nbsp;" : "" ;
	    $retStr .= ( ($recordsPerPage + $lo) < $numResults ) ? "&nbsp;<a href=" . $pageName . "?lo=" . ( $recordsPerPage + $lo ) . ">Next &gt;&gt;</a>" : "";
    }

	return "<font size=\"-2\">" . $retStr . "</font>";
}

//*****
// Build the SELECT list of states
function buildStateList( $formName = "state", $selected = "" )
{
    $retStr = "<select name=\"$formName\">\n";
    $retStr .= " <option value=\"\"> Choose a State\n";
    $retStr .= ( strcasecmp( $selected, "AL" ) == 0 ) ? " <option selected value=\"AL\"> Alabama\n" : " <option value=\"AL\"> Alabama\n";
    $retStr .= ( strcasecmp( $selected, "AK" ) == 0 ) ? " <option selected value=\"AK\"> Alaska\n" : " <option value=\"AK\"> Alaska\n";
    $retStr .= ( strcasecmp( $selected, "AZ" ) == 0 ) ? " <option selected value=\"AZ\"> Arizona\n" : " <option value=\"AZ\"> Arizona\n";
    $retStr .= ( strcasecmp( $selected, "AR" ) == 0 ) ? " <option selected value=\"AR\"> Arkansas\n" : " <option value=\"AR\"> Arkansas\n";
    $retStr .= ( strcasecmp( $selected, "CA" ) == 0 ) ? " <option selected value=\"CA\"> California\n" : " <option value=\"CA\"> California\n";
    $retStr .= ( strcasecmp( $selected, "CO" ) == 0 ) ? " <option selected value=\"CO\"> Colorado\n" : " <option value=\"CO\"> Colorado\n";
    $retStr .= ( strcasecmp( $selected, "CT" ) == 0 ) ? " <option selected value=\"CT\"> Connecticut\n" : " <option value=\"CT\"> Connecticut\n";
    $retStr .= ( strcasecmp( $selected, "DC" ) == 0 ) ? " <option selected value=\"DC\"> Washington D.C.\n" : " <option value=\"DC\"> Washington D.C.\n";
    $retStr .= ( strcasecmp( $selected, "DE" ) == 0 ) ? " <option selected value=\"DE\"> Delaware\n" : " <option value=\"DE\"> Delaware\n" ;
    $retStr .= ( strcasecmp( $selected, "FL" ) == 0 ) ? " <option selected value=\"FL\"> Florida\n" : " <option value=\"FL\"> Florida\n";
    $retStr .= ( strcasecmp( $selected, "GA" ) == 0 ) ? " <option selected value=\"GA\"> Georgia\n" : " <option value=\"GA\"> Georgia\n";
    $retStr .= ( strcasecmp( $selected, "HI" ) == 0 ) ? " <option selected value=\"HI\"> Hawaii\n" : " <option value=\"HI\"> Hawaii\n";
    $retStr .= ( strcasecmp( $selected, "ID" ) == 0 ) ? " <option selected value=\"ID\"> Idaho\n" : " <option value=\"ID\"> Idaho\n";
    $retStr .= ( strcasecmp( $selected, "IL" ) == 0 ) ? " <option selected value=\"IL\"> Illinois\n" : " <option value=\"IL\"> Illinois\n";
    $retStr .= ( strcasecmp( $selected, "IN" ) == 0 ) ? " <option selected value=\"IN\"> Indiana\n" : " <option value=\"IN\"> Indiana\n";
    $retStr .= ( strcasecmp( $selected, "IA" ) == 0 ) ? " <option selected value=\"IA\"> Iowa\n" : " <option value=\"IA\"> Iowa\n";
    $retStr .= ( strcasecmp( $selected, "KS" ) == 0 ) ? " <option selected value=\"KS\"> Kansas\n" : " <option value=\"KS\"> Kansas\n";
    $retStr .= ( strcasecmp( $selected, "KY" ) == 0 ) ? " <option selected value=\"KY\"> Kentucky\n" : " <option value=\"KY\"> Kentucky\n";
    $retStr .= ( strcasecmp( $selected, "LA" ) == 0 ) ? " <option selected value=\"LA\"> Louisiana\n" : " <option value=\"LA\"> Louisiana\n";
    $retStr .= ( strcasecmp( $selected, "ME" ) == 0 ) ? " <option selected value=\"ME\"> Maine\n" : " <option value=\"ME\"> Maine\n";
    $retStr .= ( strcasecmp( $selected, "MD" ) == 0 ) ? " <option selected value=\"MD\"> Maryland\n" : " <option value=\"MD\"> Maryland\n";
    $retStr .= ( strcasecmp( $selected, "MA" ) == 0 ) ? " <option selected value=\"MA\"> Massachusetts\n" : " <option value=\"MA\"> Massachusetts\n";
    $retStr .= ( strcasecmp( $selected, "MI" ) == 0 ) ? " <option selected value=\"MI\"> Michigan\n" : " <option value=\"MI\"> Michigan\n";
    $retStr .= ( strcasecmp( $selected, "MN" ) == 0 ) ? " <option selected value=\"MN\"> Minnesota\n" : " <option value=\"MN\"> Minnesota\n";
    $retStr .= ( strcasecmp( $selected, "MS" ) == 0 ) ? " <option selected value=\"MS\"> Mississippi\n" : " <option value=\"MS\"> Mississippi\n";
    $retStr .= ( strcasecmp( $selected, "MO" ) == 0 ) ? " <option selected value=\"MO\"> Missouri\n" : " <option value=\"MO\"> Missouri\n";
    $retStr .= ( strcasecmp( $selected, "MT" ) == 0 ) ? " <option selected value=\"MT\"> Montana\n" : " <option value=\"MT\"> Montana\n";
    $retStr .= ( strcasecmp( $selected, "NE" ) == 0 ) ? " <option selected value=\"NE\"> Nebraska\n" : " <option value=\"NE\"> Nebraska\n";
    $retStr .= ( strcasecmp( $selected, "NV" ) == 0 ) ? " <option selected value=\"NV\"> Nevada\n" : " <option value=\"NV\"> Nevada\n";
    $retStr .= ( strcasecmp( $selected, "NH" ) == 0 ) ? " <option selected value=\"NH\"> New Hampshire\n" : " <option value=\"NH\"> New Hampshire\n";
    $retStr .= ( strcasecmp( $selected, "NJ" ) == 0 ) ? " <option selected value=\"NJ\"> New Jersey\n" : " <option value=\"NJ\"> New Jersey\n";
    $retStr .= ( strcasecmp( $selected, "NM" ) == 0 ) ? " <option selected value=\"NM\"> New Mexico\n" : " <option value=\"NM\"> New Mexico\n";
    $retStr .= ( strcasecmp( $selected, "NY" ) == 0 ) ? " <option selected value=\"NY\"> New York\n" : " <option value=\"NY\"> New York\n";
    $retStr .= ( strcasecmp( $selected, "NC" ) == 0 ) ? " <option selected value=\"NC\"> North Carolina\n" : " <option value=\"NC\"> North Carolina\n";
    $retStr .= ( strcasecmp( $selected, "ND" ) == 0 ) ? " <option selected value=\"ND\"> North Dakota\n" : " <option value=\"ND\"> North Dakota\n";
    $retStr .= ( strcasecmp( $selected, "OH" ) == 0 ) ? " <option selected value=\"OH\"> Ohio\n" : " <option value=\"OH\"> Ohio\n";
    $retStr .= ( strcasecmp( $selected, "OK" ) == 0 ) ? " <option selected value=\"OK\"> Oklahoma\n" : " <option value=\"OK\"> Oklahoma\n";
    $retStr .= ( strcasecmp( $selected, "OR" ) == 0 ) ? " <option selected value=\"OR\"> Oregon\n" : " <option value=\"OR\"> Oregon\n";
    $retStr .= ( strcasecmp( $selected, "PA" ) == 0 ) ? " <option selected value=\"PA\"> Pennsylvania\n" : " <option value=\"PA\"> Pennsylvania\n";
    $retStr .= ( strcasecmp( $selected, "RI" ) == 0 ) ? " <option selected value=\"RI\"> Rhode Island\n" : " <option value=\"RI\"> Rhode Island\n";
    $retStr .= ( strcasecmp( $selected, "SC" ) == 0 ) ? " <option selected value=\"SC\"> South Carolina\n" : " <option value=\"SC\"> South Carolina\n";
    $retStr .= ( strcasecmp( $selected, "SD" ) == 0 ) ? " <option selected value=\"SD\"> South Dakota\n" : " <option value=\"SD\"> South Dakota\n";
    $retStr .= ( strcasecmp( $selected, "TN" ) == 0 ) ? " <option selected value=\"TN\"> Tennessee\n" : " <option value=\"TN\"> Tennessee\n";
    $retStr .= ( strcasecmp( $selected, "TX" ) == 0 ) ? " <option selected value=\"TX\"> Texas\n" : " <option value=\"TX\"> Texas\n";
    $retStr .= ( strcasecmp( $selected, "UT" ) == 0 ) ? " <option selected value=\"UT\"> Utah\n" : " <option value=\"UT\"> Utah\n";
    $retStr .= ( strcasecmp( $selected, "VT" ) == 0 ) ? " <option selected value=\"VT\"> Vermont\n" : " <option value=\"VT\"> Vermont\n";
    $retStr .= ( strcasecmp( $selected, "VA" ) == 0 ) ? " <option selected value=\"VA\"> Virginia\n" : " <option value=\"VA\"> Virginia\n";
    $retStr .= ( strcasecmp( $selected, "WA" ) == 0 ) ? " <option selected value=\"WA\"> Washington\n" : " <option value=\"WA\"> Washington\n";
    $retStr .= ( strcasecmp( $selected, "WV" ) == 0 ) ? " <option selected value=\"WV\"> West Virginia\n" : " <option value=\"WV\"> West Virginia\n";
    $retStr .= ( strcasecmp( $selected, "WI" ) == 0 ) ? " <option selected value=\"WI\"> Wisconsin\n" : " <option value=\"WI\"> Wisconsin\n";
    $retStr .= ( strcasecmp( $selected, "WY" ) == 0 ) ? " <option selected value=\"WY\"> Wyoming\n" : " <option value=\"WY\"> Wyoming\n";
    $retStr .= "</select>\n";

    return $retStr;
}

?>
