<?
/*
* phorSale - An eCommerce application for PHP and mySQL.
* Copyright (C) 2001 Michael Kmiec <mike@shifter.org>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// *****
// Format the order for email
function formatOrderForEmail( $order, $id, $version, $cc = "" )
{
    $retstr = "";

    if ( strcmp( $version, "customer" ) == 0 )
    {   
        $retstr .= "Thank you for your recent order with eCommerce Company (Order Number $id). Here are the details of your order. Please keep this email as a reciept.\n\n";
        $retstr .= "Order Number: $id \n\n";

        $retstr .= "Shipping Information:\n---------------\n";
        $retstr .= $order["ship_name"] . "\n";
        if ( strlen( $order["ship_company"] ) ) 
            $retstr .= $order["ship_company"];
        $retstr .= $order["ship_addr_1"] . "\n";
        if ( strlen( $order["ship_addr_2"] ) )
            $retstr .= $order["ship_addr_2"] . "\n";
        $retstr .= $order["ship_city"] . ", " . $order["ship_state"] . " " . $order["ship_postal_code"] . "\n";
        if ( strlen( $order["ship_country"] ) ) 
            $retstr .= $order["ship_country"] . "\n";
        $retstr .= "Telephone: " . $order["ship_phone"] . "\n";
        if ( strlen( $order["ship_fax"] ) ) 
            $retstr .= "Fax: " . $order["ship_fax"] . "\n";
        $retstr .= "eMail: " . $order["ship_email"] . "\n\n";

        $retstr .= "Billing Information:\n---------------\n";
        $retstr .= $order["bill_name"] . "\n";
        if ( strlen( $order["bill_company"] ) ) 
            $retstr .= $order["bill_company"];
        $retstr .= $order["bill_addr_1"] . "\n";
        if ( strlen( $order["bill_addr_2"] ) )
            $retstr .= $order["bill_addr_2"] . "\n";
        $retstr .= $order["bill_city"] . ", " . $order["bill_state"] . " " . $order["bill_postal_code"] . "\n";
        if ( strlen( $order["bill_country"] ) ) 
            $retstr .= $order["bill_country"] . "\n";
        $retstr .= "Telephone: " . $order["bill_phone"] . "\n";
        if ( strlen( $order["bill_fax"] ) ) 
            $retstr .= "Fax: " . $order["bill_fax"] . "\n";
        $retstr .= "eMail: " . $order["bill_email"] . "\n\n";

        $retstr .= "Order Details:\n---------------\n";
        if ( count( $order["items"] ) > 0) 
        { 
            $item = $order["items"];
            $subtotal = ( $item[ "quantity" ] * $item[ "price" ] );
            $finalCost = ( $subtotal + $order[ "ship_price" ] + $order[ "additional_cost" ] );
            $order[ "final_cost" ] = $finalCost;
    
            $retstr .= "Product ID: " . $item[ "id" ] ."\n";
            $retstr .= "Product Name: " . $item[ "name" ] ."\n";

            $retstr .= "Product Options: ";
            // what color the item is
            if ( strlen( $item[color] ) )
                $retstr .= "\n\tProduct Color: " . $item[color];
            // any other chosen option
            if ( strlen( $item[option_one] ) )
                $retstr .= "\n\t" . $item[option_one_name] . ": " . $item[option_one];
            if ( strlen( $item[option_two] ) )
                $retstr .= "\n\t" . $item[option_two_name] . ": " . $item[option_two];
            if ( strlen( $item[option_three] ) )
                $retstr .= "\n\t" . $item[option_three_name] . ": " . $item[option_three];
            if ( strlen( $item[option_four] ) )
                $retstr .= "\n\t" . $item[option_four_name] . ": " . $item[option_four]; 
            $retstr .= "\n";


            $retstr .= "Unit Price: $" . $item[ "price" ] ."\n";
            $retstr .= "Quantity: " . $item[ "quantity" ] ."\n";
            $retstr .= "Subtotal: $" . sprintf("%01.2f", $subtotal ) ."\n\n";
        }

        $retstr .= "Shipping Information:\n---------------\n";
        if ( strlen( $order["ship_num_type"] ) && strlen( $order["shipping_number"] ) )
            $retstr .= "Shipping with " . $order[ "ship_method" ] . " " . $order[ "shipping_number" ] . "\n\n";
        else
            $retstr .= "Shipping via " . $order[ "ship_method" ] . ", $" . sprintf("%01.2f", $order[ "ship_price" ] ) . "\n\n";

        if ( strlen( $order[ "additional_cost" ] ) )
        {
            $retstr .= "Additional Charges:\n---------------\n";
            $retstr .= $order[ "additional_charges" ] . ", $" . sprintf("%01.2f", $order[ "additional_cost" ] ) . "\n\n";
        }

        $type = ( $cc["cc_type"] == "vs" ) ? "VISA" : "MasterCard";
        $endNum = substr( $cc["cc_number"], -4 ); 

        $retstr .= "Final Cost: $" . sprintf("%01.2f", $finalCost ) . ", charged to $type ending in \"$endNum\".\n\n";       

    }
    else if ( $version == "store" )
    {
        $retstr .= "Order Number: $id \n";

        $retstr .= "Shipping Information:\n---------------\n";
        $retstr .= $order["ship_name"] . "\n";
        if ( strlen( $order["ship_company"] ) ) 
            $retstr .= $order["ship_company"];
        $retstr .= $order["ship_addr_1"] . "\n";
        if ( strlen( $order["ship_addr_2"] ) )
            $retstr .= $order["ship_addr_2"] . "\n";
        $retstr .= $order["ship_city"] . ", " . $order["ship_state"] . " " . $order["ship_postal_code"] . "\n";
        if ( strlen( $order["ship_country"] ) ) 
            $retstr .= $order["ship_country"] . "\n";
        $retstr .= "Telephone: " . $order["ship_phone"] . "\n";
        if ( strlen( $order["ship_fax"] ) ) 
            $retstr .= "Fax: " . $order["ship_fax"] . "\n";
        $retstr .= "eMail: " . $order["ship_email"] . "\n\n";

        $retstr .= "Billing Information:\n---------------\n";
        $retstr .= $order["bill_name"] . "\n";
        if ( strlen( $order["bill_company"] ) ) 
            $retstr .= $order["bill_company"];
        $retstr .= $order["bill_addr_1"] . "\n";
        if ( strlen( $order["bill_addr_2"] ) )
            $retstr .= $order["bill_addr_2"] . "\n";
        $retstr .= $order["bill_city"] . ", " . $order["bill_state"] . " " . $order["bill_postal_code"] . "\n";
        if ( strlen( $order["bill_country"] ) ) 
            $retstr .= $order["bill_country"] . "\n";
        $retstr .= "Telephone: " . $order["bill_phone"] . "\n";
        if ( strlen( $order["bill_fax"] ) ) 
            $retstr .= "Fax: " . $order["bill_fax"] . "\n";
        $retstr .= "eMail: " . $order["bill_email"] . "\n\n";

        $retstr .= "Order Details:\n---------------\n";
        if ( count( $order["items"] ) > 0) 
        { 
            $item = $order["items"];
            $subtotal = ( $item[ "quantity" ] * $item[ "price" ] );
            $finalCost = ( $subtotal + $order[ "ship_price" ] + $order[ "additional_cost" ] );
            $order[ "final_cost" ] = $finalCost;
    
            $retstr .= "Product ID: " . $item[ "id" ] ."\n";
            $retstr .= "Product Name: " . $item[ "name" ] ."\n";

            $retstr .= "Product Options: ";
            // what color the item is
            if ( strlen( $item[color] ) )
                $retstr .= "\n\tProduct Color: " . $item[color];
            // any other chosen option
            if ( strlen( $item[option_one] ) )
                $retstr .= "\n\t" . $item[option_one_name] . ": " . $item[option_one];
            if ( strlen( $item[option_two] ) )
                $retstr .= "\n\t" . $item[option_two_name] . ": " . $item[option_two];
            if ( strlen( $item[option_three] ) )
                $retstr .= "\n\t" . $item[option_three_name] . ": " . $item[option_three];
            if ( strlen( $item[option_four] ) )
                $retstr .= "\n\t" . $item[option_four_name] . ": " . $item[option_four];
            $retstr .= "\n";

            $retstr .= "Unit Price: $" . $item[ "price" ] ."\n";
            $retstr .= "Quantity: " . $item[ "quantity" ] ."\n";
            $retstr .= "Subtotal: $" . sprintf("%01.2f", $subtotal ) ."\n\n";
        }

        $retstr .= "Shipping Information:\n---------------\n";
        if ( strlen( $order["ship_num_type"] ) && strlen( $order["shipping_number"] ) )
            $retstr .= "Shipping with " . $order[ "ship_method" ] . " " . $order[ "shipping_number" ] . "\n\n";
        else
            $retstr .= "Shipping via " . $order[ "ship_method" ] . ", $" . sprintf("%01.2f", $order[ "ship_price" ] ) . "\n\n";

        if ( strlen( $order[ "additional_cost" ] ) )
        {
            $retstr .= "Additional Charges:\n---------------\n";
            $retstr .= $order[ "additional_charges" ] . ", $" . sprintf("%01.2f", $order[ "additional_cost" ] ) . "\n\n";
        }

        $retstr .= "Final Cost: $" . sprintf("%01.2f", $finalCost ) . "\n\n";

        // NOTE: Uncommenting the following will send the user's credit card info
        // to the store in email. BIG SECURITY RISK, but it's in here in case 
        // such actions are deemed necessary.
        /**
        ** $cardType = ( $cc["cc_type"] == "vs" ) ? "VISA" : "MasterCard";      
        ** $retstr .= "Credit Card Information:\n---------------\n";
        ** $retstr .= "Credit Card Type: " . $cardType . "\n";
        ** $retstr .= "Credit Card Number: " . $cc["cc_number"] . "\n";
        ** $retstr .= "Credit Card Expiration: " . $cc["cc_exp_m"] . "/" . $cc["cc_exp_y"] . "\n";     
        */
    }

    return $retstr;
}
 
// *****
// Send email to shopper, notifying them of order recieved by store.
function sendOrderEmailToShopper( $to, $order, $orderID, $ccinfo )
{   
    $subject = "Your Order ($orderID)";
    $message = formatOrderForEmail( $order, $orderID, "customer", $ccinfo ); 
    return sendEmail( $to, "ORDERS", $subject, $message );
}

// *****
// Send email to store, notifying them of order recieved.
function sendOrderEmailToStore( $order, $orderID, $ccinfo )
{
    global $ordersEmail;

    $to = $ordersEmail;
    $subject = "Order Recieved: $orderID";
    $message = "An order has been recieved: \n\n";
    $message .= formatOrderForEmail( $order, $orderID, "store", $ccinfo );
    return sendEmail( $to, "STORE", $subject, $message );
}

// *****
// Send email to store, notifying them of contact information.
function sendContactFormToStore( $from, $subj, $msg )
{
    global $contactEmail;

    $to = $contactEmail;    
    $subject = ( strlen( $subj ) ) ? "Contact Form: $subj" : "eCommerce Contact Form";
    return sendEmail( $to, $from, $subject, $msg );
}

// *****
// Send email to shopper with their password
function sendPasswordEmailToShopper( $to, $pwd )
{   
    $subject = "eCommerce Company Information";
    $message = "You recently requested your Login Information from eCommerce Company. Please keep this eMail in a safe place so ";
    $message .= "no one has access to your account. Thanks.\n";
    $message .= "You can login by going to <https://YOUR_DOMAIN_HERE/shopperCheck.php>.\n\n";

    $message .= "eMail Address: " . $to . "\n";
    $message .= "Password: " . $pwd . "\n";

    return sendEmail( $to, "CUST_SVC", $subject, $message );
}

// *****
// Generic email function.
function sendEmail( $to, $from, $subject, $message )
{
    global $OS, $storeEmail, $ordersEmail, $customerServiceEmail;

    $retAdd = "";
    switch( $from )
    {
        case "STORE":
            $retAdd = "eCommerce Store <$storeEmail>";
            break;
        case "ORDERS":
            $retAdd = "eCommerce Orders <$ordersEmail>";
            break;
        case "CUST_SVC":
            $retAdd = "eCommerce Customer Service <$customerServiceEmail>";
            break;
        default:
            $retAdd = "<$from>";
            break;
    }

    if ( $OS == "Windows_NT" )
    {
        // don't know how to set up a mailer on NT, so...
        return true;
    }
    else
    {
        // running on *nix
        $outheaders .= "From: $retAdd\n";
        $outheaders .= "X-Sender: eComm\n"; 
        $outheaders .= "Return-Path: <errors@YOUR_DOMAIN_HERE>\n";  // return path for errors

        return mail ( $to, $subject, $message, $outheaders );
    }
}
?>
