<? 
/*
* phorSale - An eCommerce application for PHP and mySQL.
* Copyright (C) 2001 Michael Kmiec <mike@shifter.org>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*****
*
*   Display the order summary for the user.
*
*****/

// register the order object, for persistance sake
session_start();

// standard include files
require ("common/config.inc.php");
include("common/order.functions.inc.php");
include("common/mail.functions.inc.php");
include("common/shopper.functions.inc.php");

// for credit card integrity check
include( "common/credit_card.inc.php" );

// for CyberCash wrapper 
include( "common/CyberCashWrapper.inc.php" );

// definitions
$sID = session_id();
$nextPage = "receipt.php";

if ( isSet( $PO ) )
{    
    // validate necessary information
    $errMsg = "";
    if ( !strlen( $cc_type ) )
        $errMsg .= "<li> You must select a Credit Card Type.";
    else if ( !strlen( $cc_number ) )
        $errMsg .= "<li> You must enter a Credit Card Number.";
    else if ( !strlen( $cc_exp_m ) )
        $errMsg .= "<li> You must enter a Credit Card Expiration Month.";
    else if ( !strlen( $cc_exp_y ) )
        $errMsg .= "<li> You must enter a Credit Card Expiration Year.";

    // now, do credit card integrity check
    if ( strlen( $errMsg ) == 0 )
    {
        $ccCheck = new credit_card();
        list ($valid, $type) = $ccCheck->check( $cc_number );

        if( !$valid )
            $errMsg .= "<li> The Credit Card Number entered is invalid. Please enter a valid Credit Card Number.";
        else
        {
            if ( $type == "Visa" && $cc_type == "mc" )
                $errMsg .= "<li> The Credit Card Number entered does not match the Credit Card Type selected (MasterCard). Please enter a valid Credit Card Number.";
            else if ( $type == "Mastercard" && $cc_type == "vs" )
                $errMsg .= "<li> The Credit Card Number entered does not match the Credit Card Type selected (VISA). Please enter a valid Credit Card Number.";
            else if ( $type != "Visa" && $type != "Mastercard" )
                $errMsg .= "<li> The Credit Card Number entered is invalid. Please enter a valid Credit Card Number.";
            else if ( !$ccCheck->validDate( $cc_exp_m, $cc_exp_y ) )
                $errMsg .= "<li> The Credit Card entered has expired. Please enter a valid Credit Card.";
        }
    }

    if ( strlen( $errMsg ) == 0 )
    {            
        // generate an order number
        $orderID = uniqid( "EC" );

        // credit array
        $cc = array();
        $cc["cc_type"] = $cc_type;
        $cc["cc_number"] = $ccCheck->clean_no( $cc_number );
        $cc["cc_exp_m"] = $cc_exp_m;
        $cc["cc_exp_y"] = $cc_exp_y;

        // now, send order and payment info off to the CyberCash CGI
        $CCW = new CyberCashWrapper( $orderID, $order, $cc );
        $CCW->getResponse();

        // If the CyberCash approval transaction has failed, don't proceed.
        //if( !($retmsg = $CCW->getStatus()) )
        if( !($retmsg = true) )
        {    
            $type = ( $cc["cc_type"] == "vs" ) ? "VISA" : "MasterCard";
            $endNum = substr( $cc["cc_number"], -4 ); 

            if ( $CCW->isDeclined && $CCW->isExpired )             
                $errMsg .= "<li> The Credit Card you entered ($type, ending in \"$endNum\") is expired. Please try another Credit Card, or Customer Service at $customerServiceNumber for assistance.";
            else if ( $CCW->isDeclined )  
                    $errMsg .= "<li> The Credit Card you entered ($type, ending in \"$endNum\") has been declined. Please try another Credit Card, or Customer Service at $customerServiceNumber for assistance.";
            else
            {
                $errMsg .= "<li> There has been an error processing the Credit Card you entered ($type, ending in \"$endNum\"). Please try another Credit Card, or Customer Service at $customerServiceNumber for assistance, mentioning the error message below.";
                $errMsg .= "<br><font size=\"1\" color=\"#000000\">(Error Message: " . $CCW->getMessage() . ")</font>";
            }
        }

        if( $retmsg )
        {
            // if credit approval comes back positive, set the order status
            $order["status"] = "approved";                        

            // save the order to the database, sans cc info.
            if ( ( $dbh =  mysql_connect( $dbServer, $dbUser, $dbPassword )) > 0 )
            {
                //put the serialized order in the database; we'll unserialize later.
                $sql_query = "INSERT INTO $orderTable ( order_id, shopper_id, placed, order_info ) VALUES ( '$orderID', '$shopperID', NOW(), '" . addslashes( serialize( $order ) ) . "' )";

                $res = mysql_db_query($dbDatabase, $sql_query, $dbh);
                $err = mysql_error();
            }

            $dbh = mysql_close();
            
            // tie up some loose ends
            if ( !$err ) 
            {
                // get necessary shopper info
                $shopper = getShopper( $shopperID );
                
                // send an email to the shopper                
                sendOrderEmailToShopper( $shopper[email], $order, $orderID, $cc );

                // send an email notification to store
                sendOrderEmailToStore( $order, $orderID, $cc );

                // send user to next page
                header("Location: " . $nextPage . "?eCommID=" . $shopperID . "&PHPSESSID=" . $sID . "&OID=" . $orderID );
            }
        }
    }
}
?>

<? $title = "Order Summary"; ?>
<? require 'common/header.inc.php'; ?>

<font face="<?echo $fontTag;?>" SIZE="+2" COLOR="#000000">Order Summary</font><hr size="1">

<?
    if ( isSet( $CCW ) )
        echo( "<!-- " . $CCW->getMessage() . " -->" );
?>

<form action="<?echo basename($PHP_SELF);?>" method="POST">
<input type="hidden" name="eCommID" value="<?echo $shopperID;?>">
<input type="hidden" name="PHPSESSID" value="<?echo $sID;?>">
<input type="hidden" name="decl" value="<?echo $decl;?>">
<input type="hidden" name="PO" value="1">

<!-- constraining table -->
<table border="0" cellpadding="3" cellspacing="0" align="center" width="600">
    <tr>
        <td>
            <table border="0" cellpadding="3" cellspacing="0" align="center" width="600">
            <?
                if ( strlen( $errMsg ) ) 
                {
            ?>
                <tr>
                    <td colspan="2" align="left">
                        <font face="<?echo $fontTag; ?>" size="2" color="#CC0000"><b>
                            There appears to be a problem...
                        <ul><?echo $errMsg;?></ul>
                        </b></font><p>
                    </td>
                </tr>
            <?
                }
            ?>
                <tr bgcolor="#E7E7E9">
                    <td><font face="<?echo $fontTag;?>" SIZE="1"><b>Shipping To:</b></font></td>
                    <td><font face="<?echo $fontTag;?>" SIZE="1"><b>Billing To:</b></font></td>
                    <td colspan="3">&nbsp;</td>
                </tr>
                <tr>
                    <td align="left">
                        <font face="<?echo $fontTag;?>" SIZE="-1">
                        <? 
                            // shipping address, from the order
                            echo $order["ship_name"] . "<br>";
                    
                            if ( strlen( $order["ship_company"] ) ) 
                                echo $order["ship_company"] . "<br>";

                            echo $order["ship_addr_1"] . "<br>";

                            if ( strlen( $order["ship_addr_2"] ) )
                                echo $order["ship_addr_2"] . "<br>";

                            echo $order["ship_city"] . ", " . $order["ship_state"] . " " . $order["ship_postal_code"] . "<br>";

                            if ( strlen( $order["ship_country"] ) ) 
                                echo "Country: " . $order["ship_country"] . "<br>";

                            echo "Telephone: " . $order["ship_phone"] . "<br>";

                            if ( strlen( $order["ship_fax"] ) ) 
                                echo "Fax: " . $order["ship_fax"] . "<br>";

                            echo "eMail: " . $order["ship_email"] . "<br>";
                        ?>
                    </td>            
                    <td align="left">
                        <font face="<?echo $fontTag;?>" SIZE="-1">
                        <?
                            // billing address, from the order
                            echo $order["bill_name"] . "<br>";
                    
                            if ( strlen( $order["bill_company"] ) ) 
                                echo $order["bill_company"] . "<br>";

                            echo $order["bill_addr_1"] . "<br>";

                            if ( strlen( $order["bill_addr_2"] ) )
                                echo $order["bill_addr_2"] . "<br>";

                            echo $order["bill_city"] . ", " . $order["bill_state"] . " " . $order["bill_postal_code"] . "<br>";

                            if ( strlen( $order["bill_country"] ) ) 
                                echo $order["bill_country"] . "<br>";

                            echo "Telephone: " . $order["bill_phone"] . "<br>";                    

                            if ( strlen( $order["bill_fax"] ) ) 
                                echo "Fax: " . $order["bill_fax"] . "<br>";

                            echo "eMail: " . $order["bill_email"] . "<br>";
                        ?>
                    </td>
                    <td colspan="3">&nbsp;</td>
                </tr>
            </table>
        </td>
    <tr>
    <tr>
        <td>
            <table border="0" cellpadding="3" cellspacing="0" align="center" width="600">
            <? 
                if ( count( $order["items"] ) > 0) 
                { 
            ?>
                    <!-- product information -->
                    <tr bgcolor="#E7E7E9">
                        <td><font face="<?echo $fontTag;?>" size="1"><b>Product ID</b></font></td>
                        <td><font face="<?echo $fontTag;?>" size="1"><b>Product Name</b></font></td>
                        <td><font face="<?echo $fontTag;?>" size="1"><b>Unit Price</b></font></td>
                        <td><font face="<?echo $fontTag;?>" size="1"><b>Quantity</b></font></td>            
                        <td align="right"><font face="<?echo $fontTag;?>" size="1"><b>Subtotal</b></font></td>
                    </tr>
            <?
                    for ( $ctr = 0; $ctr < count( $order["items"] ); $ctr++ )
                    {
                        $item = $order["items"][$ctr];

                        $itemPrice = 0.00;
                        if ( $item[specialPrice] > 0 )
                            $itemPrice = $item[specialPrice];
                        else
                            $itemPrice = $item[price];

                        $subtotal = ( $item[ "quantity" ] * $itemPrice );
                        $runningSub += $subtotal;
            ?>                
                    <tr>
                        <td><font face="<?echo $fontTag;?>" size="-1"><? echo $item[ "id" ]; ?></font></td>
                        <td><font face="<?echo $fontTag;?>" size="-1"><? echo $item[ "name" ]; ?></font></td>
                        <td><font face="<?echo $fontTag;?>" size="-1">$<? echo $itemPrice; ?></td>
                        <td><font face="<?echo $fontTag;?>" size="-1"><? echo $item[ "quantity" ]; ?></font></td>
                        <td align="right"><font face="<?echo $fontTag;?>" size="-1">$<? echo sprintf("%01.2f", $subtotal ); ?></font></td>
                    </tr>
                    <tr>
                        <td colspan="5" bgcolor="#E7E7E9">
                            <font face="<?echo $fontTag;?>" SIZE="1">
                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>Product Options:</b>
                                <?
                                    // what color the item is
                                    if ( strlen( $item[color] ) )
                                        echo "Product Color: " . $item[color];
                                    // any other chosen option
                                    if ( strlen( $item[option_one] ) )
                                        echo "; " . $item[option_one_name] . ": " . $item[option_one];
                                    if ( strlen( $item[option_two] ) )
                                        echo "; " . $item[option_two_name] . ": " . $item[option_two];
                                    if ( strlen( $item[option_three] ) )
                                        echo "; " . $item[option_three_name] . ": " . $item[option_three];
                                    if ( strlen( $item[option_four] ) )
                                        echo "; " . $item[option_four_name] . ": " . $item[option_four];                
                                ?>                                
                            </font>
                        </td>
                    </tr>
                <?
                    } // end "for" loop                    
                ?>
                <tr>
                    <td colspan="5">&nbsp;</td>                    
                </tr>
                <!-- shipping information -->
                <tr>
                    <td colspan="5" bgcolor="#E7E7E9"><font face="<?echo $fontTag;?>" size="1"><b>Shipping</b></font></td>                    
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <?
                        if ( strlen( $order["ship_num_type"] ) && strlen( $order["shipping_number"] ) )
                        {
                    ?>
                    <td colspan="3"><font face="<?echo $fontTag;?>" size="-1">Shipping with <? echo $order[ "ship_method" ]; ?> <b><? echo $order[ "shipping_number" ]; ?><b></font></td>
                    <td align="right"><font face="<?echo $fontTag;?>" size="-1">n/c</font></td>
                    <?  
                        }
                        else
                        {
                    ?>
                    <td colspan="3"><font face="<?echo $fontTag;?>" size="-1">Shipping via <? echo $order[ "ship_method" ]; ?></font></td>
                    <td align="right"><font face="<?echo $fontTag;?>" size="-1">$<? echo sprintf("%01.2f", $order[ "ship_price" ] ); ?></font></td>
                    <?
                        }
                    ?>
                </tr>

                <?  if ( strlen( $order[ "additional_cost" ] ) )
                    {
                ?>
                <!-- additional charges -->
                <tr bgcolor="#E7E7E9">
                    <td colspan="5"><font face="<?echo $fontTag;?>" size="1"><b>Additional Charges</b></font></td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td colspan="3"><font face="<?echo $fontTag;?>" size="-1"><? echo $order[ "additional_charges" ]; ?></font></td>
                    <td align="right"><font face="<?echo $fontTag;?>" size="-1">$<? echo sprintf("%01.2f", $order[ "additional_cost" ] ); ?></font></td>
                </tr>
                <?  } ?>
        
                <tr bgcolor="#E7E7E9">
                    <td colspan="5">&nbsp;</td>
                </tr>
                <?
                    $finalCost = ( $runningSub + $order[ "ship_price" ] + $order[ "additional_cost" ] );
                    $order[ "final_cost" ] = $finalCost;
                ?>
                <!-- final cost -->
                <tr>
                    <td>&nbsp;</td>
                    <td colspan="3" align="right"><font face="<?echo $fontTag;?>"><b>Final Cost:</b></font></td>
                    <td align="right"><font face="<?echo $fontTag;?>">$<? echo sprintf("%01.2f", $finalCost ); ?></font></td>
                </tr>
                <tr>
                    <td colspan="5">&nbsp;</td>
                </tr>
                <tr bgcolor="#E7E7E9">
                    <td colspan="5"><font face="<?echo $fontTag;?>" size="1"><b>Credit Card Information</b></font></td>
                </tr>
                <tr>                    
                    <td colspan="5" align="center">
                        <font face="<?echo $fontTag;?>" size="2">Credit Card Type: </font>
                        <select size="1" name="cc_type">
                            <option value="">Select Credit Card Type
                            <option value="vs"> VISA
                            <option value="mc"> MasterCard
                        </select>
                    </td>
                </tr>
                <tr>
                    <td colspan="5" align="center"><font face="<?echo $fontTag;?>" size="2">Credit Card Number: </font>&nbsp;<input type="text" maxlength="40" name="cc_number" size="30"></td>
                </tr>
                <tr>
                    <td colspan="5" align="center">
                    <font face="<?echo $fontTag;?>" size="2">Credit Card Expiration Date: </font>&nbsp;
                    <select size="1" name="cc_exp_m">
                        <option value="">Select Expiration Month
                        <option value="01"> January
                        <option value="02"> February
                        <option value="03"> March
                        <option value="04"> April
                        <option value="05"> May
                        <option value="06"> June
                        <option value="07"> July
                        <option value="08"> August
                        <option value="09"> September
                        <option value="10"> October
                        <option value="11"> November
                        <option value="12"> December
                    </select>
                    &nbsp;&nbsp;
                    <select size="1" name="cc_exp_y">
                        <option value="">Select Expiration Year
                        <option value="01"> 2001
                        <option value="02"> 2002
                        <option value="03"> 2003
                        <option value="04"> 2004
                        <option value="05"> 2005
                    </select>
                    </td>
                </tr>

                <tr bgcolor="#E7E7E9">
                    <td colspan="5">&nbsp;</td>
                </tr>

                <!-- place order button -->
                <tr>
                    <td colspan="5" align="right"><input type="submit" value="Place Order"></td>
                </tr>
            <?
            } // end "order.items" block
            ?>
            </table>
            </form>
        </td>
    </tr>
</table>
<?
  if ( count( $order["items"] ) < 1 )
    echo "<p>Your order is empty</p>";
?>

<? require 'common/footer.inc.php'; ?>
