# --------------------------------------------------------
#
# Table structure for table 'administrators'
#

CREATE TABLE administrators (
   level enum('1','2','3') DEFAULT '1' NOT NULL,
   name char(100) NOT NULL,
   password char(100) NOT NULL
);

# Data for 'administrators'; modify if necessary
INSERT INTO administrators VALUES ( '1', 'ecommadmin', 'mKg.U7wkeAWVw');


# --------------------------------------------------------
#
# Table structure for table 'sections'
#

CREATE TABLE sections (
   section_id mediumint(9) NOT NULL auto_increment,
   section_name char(50) NOT NULL,
   PRIMARY KEY (section_id)
);

# Data for table 'sections'; modify if necessary
INSERT INTO sections VALUES ( '1', 'Full Catalog');
INSERT INTO sections VALUES ( '2', 'Specials');
INSERT INTO sections VALUES ( '3', 'What\'s Hot');
INSERT INTO sections VALUES ( '4', 'Seasonal');


# --------------------------------------------------------
#
# Table structure for table 'products'
#

CREATE TABLE products (
   product_id varchar(15) NOT NULL,
   product_active enum('true','false') DEFAULT 'false',
   product_name varchar(50),
   product_desc text,
   product_section int(11) DEFAULT '1',
   product_specs varchar(255),
   product_keywords varchar(255),
   product_image blob,
   product_image_width int(11) DEFAULT '0',
   product_image_height int(11) DEFAULT '0',
   product_image_format enum('gif','jpeg','png'),
   product_colors varchar(75),
   product_option_one varchar(100),
   product_option_two varchar(100),
   product_option_three varchar(100),
   product_option_four varchar(100),
   product_weight int(11),
   product_weight_count int(11),
   product_turnaround varchar(20),
   product_disclaimer text,
   product_shipping_from varchar(15),
   product_price decimal(9,2) DEFAULT '0.00',
   product_special_price decimal(9,2) DEFAULT '0.00',
   UNIQUE product_id (product_id),
   PRIMARY KEY (product_id)
);

# --------------------------------------------------------
#
# Table structure for table 'colors'
#

CREATE TABLE colors (
   color_id int(11) NOT NULL auto_increment,
   color_name varchar(50) NOT NULL,
   color_image blob,
   color_image_width int(11) DEFAULT '0',
   color_image_height int(11) DEFAULT '0',
   color_image_format enum('gif','jpeg','png'),
   PRIMARY KEY (color_id)
);

# --------------------------------------------------------
#
# Table structure for table 'shoppers'
#

CREATE TABLE shoppers (
   shopper_id varchar(50) NOT NULL,
   shopper_email varchar(100) NOT NULL,
   shopper_password blob NOT NULL,
   shopper_send_email enum('true','false') DEFAULT 'false',
   shopper_ship_name varchar(125),
   shopper_ship_company varchar(125),
   shopper_ship_phone varchar(25),
   shopper_ship_fax varchar(25),
   shopper_ship_addr_1 varchar(100),
   shopper_ship_addr_2 varchar(100),
   shopper_ship_city varchar(100),
   shopper_ship_state varchar(10),
   shopper_ship_postal_code varchar(20),
   shopper_ship_country varchar(20),
   shopper_bill_name varchar(125),
   shopper_bill_company varchar(125),
   shopper_bill_phone varchar(25),
   shopper_bill_fax varchar(25),
   shopper_bill_addr_1 varchar(100),
   shopper_bill_addr_2 varchar(100),
   shopper_bill_city varchar(100),
   shopper_bill_state varchar(10),
   shopper_bill_postal_code varchar(20),
   shopper_bill_country varchar(20),
   PRIMARY KEY (shopper_id)
);

# --------------------------------------------------------
#
# Table structure for table 'orders'
#

CREATE TABLE orders (
   order_id varchar(100) NOT NULL,
   shopper_id varchar(50) NOT NULL,
   placed datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
   order_info blob NOT NULL,
   PRIMARY KEY (order_id)
);